//****************************************************************************
//
// SPDX-License-Identifier: MIT-0
// Copyright(c) 2017-2021 Intel Corporation.
//
//****************************************************************************
// This is a generated system top level RTL file. 



module ghrd_s10_top (
// Clock and Reset
input  wire [1-1:0]  fpga_clk_100,
input  wire [1-1:0]  fpga_reset_n,
output wire [4-1:0]  fpga_led_pio,
input  wire [4-1:0]  fpga_dipsw_pio,
input  wire [4-1:0]  fpga_button_pio,
//HPS
// HPS EMIF
output wire [0:0]    emif_hps_mem_mem_ck,
output wire [0:0]    emif_hps_mem_mem_ck_n,
output wire [16:0]   emif_hps_mem_mem_a,
output wire [0:0]    emif_hps_mem_mem_act_n,
output wire [1:0]    emif_hps_mem_mem_ba,
output wire [0:0]    emif_hps_mem_mem_bg,
output wire [0:0]    emif_hps_mem_mem_cke,
output wire [0:0]    emif_hps_mem_mem_cs_n,
output wire [0:0]    emif_hps_mem_mem_odt,
output wire [0:0]    emif_hps_mem_mem_reset_n,
output wire [0:0]    emif_hps_mem_mem_par,
input  wire [0:0]    emif_hps_mem_mem_alert_n,
input  wire          emif_hps_oct_oct_rzqin,
input  wire          emif_hps_pll_ref_clk,
inout  wire [9-1:0]  emif_hps_mem_mem_dbi_n,
inout  wire [72-1:0] emif_hps_mem_mem_dq,
inout  wire [9-1:0]  emif_hps_mem_mem_dqs,
inout  wire [9-1:0]  emif_hps_mem_mem_dqs_n,
input  wire          hps_jtag_tck,
input  wire          hps_jtag_tms,
output wire          hps_jtag_tdo,
input  wire          hps_jtag_tdi,
output wire          hps_sdmmc_CCLK, 
inout  wire          hps_sdmmc_CMD,          
inout  wire          hps_sdmmc_D0,          
inout  wire          hps_sdmmc_D1,          
inout  wire          hps_sdmmc_D2,        
inout  wire          hps_sdmmc_D3,        
inout  wire          hps_usb0_DATA0,         
inout  wire          hps_usb0_DATA1,      
inout  wire          hps_usb0_DATA2,        
inout  wire          hps_usb0_DATA3,       
inout  wire          hps_usb0_DATA4,        
inout  wire          hps_usb0_DATA5,      
inout  wire          hps_usb0_DATA6,      
inout  wire          hps_usb0_DATA7,         
input  wire          hps_usb0_CLK,         
output wire          hps_usb0_STP,       
input  wire          hps_usb0_DIR,        
input  wire          hps_usb0_NXT, 
output wire          hps_emac0_TX_CLK,       //TODO: may need to change RMII TX CLK to be input instead, check
input  wire          hps_emac0_RX_CLK,      
output wire          hps_emac0_TX_CTL,
input  wire          hps_emac0_RX_CTL,      
output wire          hps_emac0_TXD0,       
output wire          hps_emac0_TXD1,
input  wire          hps_emac0_RXD0,     
input  wire          hps_emac0_RXD1,                
output wire          hps_emac0_TXD2,        
output wire          hps_emac0_TXD3,
input  wire          hps_emac0_RXD2,        
input  wire          hps_emac0_RXD3, 
inout  wire          hps_emac0_MDIO,         
output wire          hps_emac0_MDC,
input  wire          hps_uart0_RX,       
output wire          hps_uart0_TX, 
inout  wire          hps_i2c1_SDA,        
inout  wire          hps_i2c1_SCL, 
inout  wire          hps_gpio1_io0,
inout  wire          hps_gpio1_io1,
inout  wire          hps_gpio1_io4,
inout  wire          hps_gpio1_io5,
inout  wire          hps_gpio1_io19,
inout  wire          hps_gpio1_io20,
inout  wire          hps_gpio1_io21,
input  wire          enet_refclk,
input  wire          mge_refclk_125m,
input  wire          mge_refclk_10g,

input  wire [1-1:0]    mge_10gbe_rxp,       
output wire [1-1:0]    mge_10gbe_txp,

output wire          sfpa_txdisable,
output wire [1:0]    sfpa_ratesel,
input  wire          sfpa_los,
input  wire          sfpa_txfault,
input  wire          sfpa_mod0_prstn,
inout  wire          sfpa_i2c_scl,
inout  wire          sfpa_i2c_sda,
input  wire          hps_ref_clk
);

wire         system_clk_100;
wire         system_clk_100_internal;
wire         ninit_done;
wire         fpga_reset_n_debounced_wire;
reg          fpga_reset_n_debounced;
wire         src_reset_n;
wire         system_reset_n;
wire         h2f_reset;
assign system_reset_n = fpga_reset_n_debounced & src_reset_n & ~h2f_reset & ~ninit_done;



wire sfp_i2c_scl_oe;
wire sfp_i2c_sda_oe;

wire                   mge_10gbe_clk_156p25;
wire                   mge_core_pll_locked;
wire                   mge_xcvr_sampling_pll_locked;
wire                   mge_tod_sampling_pll_locked;
wire                   mge_csr_clk;
wire                   mge_reset_csr_clk;
wire [16:0]            mge_csr_address;
wire                   mge_csr_write;
wire                   mge_csr_read;
wire                   mge_csr_waitrequest;
wire [3:0]             mge_csr_byteenable;
wire                   mge_csr_debugaccess;
wire                   mge_csr_burstcount;
wire [31:0]            mge_csr_writedata;
wire [31:0]            mge_csr_readdata;
wire                   mge_csr_readdatavalid;
wire [1-1:0]           mge_avalon_st_tx_valid;
wire [1-1:0]           mge_avalon_st_tx_ready;
wire [1-1:0]           mge_avalon_st_tx_startofpacket;
wire [1-1:0]           mge_avalon_st_tx_endofpacket;
wire [1-1:0][63:0]     mge_avalon_st_tx_data;
wire [1-1:0][ 2:0]     mge_avalon_st_tx_empty;
wire [1-1:0]           mge_avalon_st_tx_error;
wire [1-1:0]           mge_avalon_st_rx_valid;
wire [1-1:0]           mge_avalon_st_rx_ready;
wire [1-1:0]           mge_avalon_st_rx_startofpacket;
wire [1-1:0]           mge_avalon_st_rx_endofpacket;
wire [1-1:0][63:0]     mge_avalon_st_rx_data;
wire [1-1:0][ 2:0]     mge_avalon_st_rx_empty;
wire [1-1:0][ 5:0]     mge_avalon_st_rx_error;
wire [1-1:0][ 1:0]     mge_avalon_st_pause_data;
wire [1-1:0][ 1:0]     mge_xgmii_rx_link_fault_status;
wire [1-1:0]           mge_led_link;
wire [1-1:0]           mge_led_char_err;
wire [1-1:0]           mge_led_disp_err;
wire [1-1:0]           mge_led_an;
wire [1-1:0]           mge_rx_block_lock;
wire [1-1:0]           mge_channel_tx_ready;
wire [1-1:0]           mge_channel_rx_ready;
wire [1-1:0]           mge_tx_egress_timestamp_request_in_valid;
wire [1-1:0][7:0]      mge_tx_egress_timestamp_request_in_fingerprint;
wire [1-1:0]           mge_tx_egress_timestamp_96b_valid;
wire [1-1:0][95:0]     mge_tx_egress_timestamp_96b_data;
wire [1-1:0][7:0]      mge_tx_egress_timestamp_96b_fingerprint;
wire [1-1:0]           mge_rx_ingress_timestamp_96b_valid;
wire [1-1:0][95:0]     mge_rx_ingress_timestamp_96b_data;
wire [1-1:0]           mge_start_tod_sync;
wire [1-1:0]           mge_pulse_per_second;
wire                   mge_master_pulse_per_second;
    
wire [2:0]             sfp_control;    
wire [0:0]             mge_10gbe_tod_start_sync_ctrl;    
wire [2:0]             mge_10gbe_status;
wire [9:0]             mge_10gbe_debug_status;
wire [1-1:0]           mge_10gbe_mac_link_status;

wire        chan1_ready; 

assign system_clk_100   = fpga_clk_100;

assign system_clk_100_internal  = system_clk_100;

wire [3:0]     fpga_debounced_buttons;
wire [2:0]     fpga_led_internal;
wire           heartbeat_led;
reg  [22:0]    heartbeat_count;
assign fpga_led_pio = {heartbeat_led,fpga_led_internal};
assign heartbeat_led = ~heartbeat_count[22];

wire [31:0]    f2h_irq1_irq;



assign sfpa_txdisable            = sfp_control[0];
assign sfpa_ratesel              = sfp_control[2:1];
assign mge_start_tod_sync[0]     = mge_10gbe_tod_start_sync_ctrl[0];
assign mge_10gbe_status[2:0]       = {sfpa_mod0_prstn, sfpa_txfault, sfpa_los};
assign mge_10gbe_debug_status[9:0] = {mge_tod_sampling_pll_locked, mge_xcvr_sampling_pll_locked, mge_core_pll_locked, mge_rx_block_lock[0], mge_led_an[0], mge_led_disp_err[0], mge_led_char_err[0], mge_led_link[0], mge_xgmii_rx_link_fault_status[0]};
assign mge_10gbe_mac_link_status[0] = chan1_ready;

assign chan1_ready = mge_channel_tx_ready[0] & mge_channel_rx_ready[0] & mge_core_pll_locked & mge_xcvr_sampling_pll_locked & mge_tod_sampling_pll_locked;


assign sfpa_i2c_scl = (sfp_i2c_scl_oe == 1'b1) ? 1'b0 : 1'bz;
assign sfpa_i2c_sda = (sfp_i2c_sda_oe == 1'b1) ? 1'b0 : 1'bz;

wire [42:0]    stm_hw_events;

assign stm_hw_events    = 43'b0;


assign f2h_irq1_irq    = {32'b0};


// Qsys Top module
qsys_top soc_inst (
.src_prb_rst_sources_source             (src_reset_n),
.reset_reset_n                          (system_reset_n), 
.clk_100_clk                            (system_clk_100_internal),
.ninit_done_ninit_done                  (ninit_done),
.led_pio_external_connection_in_port    (fpga_led_internal),                    
.led_pio_external_connection_out_port   (fpga_led_internal),
.dipsw_pio_external_connection_export   (fpga_dipsw_pio), 
.button_pio_external_connection_export  (fpga_debounced_buttons), 
.s10_hps_f2h_stm_hw_events_stm_hwevents (stm_hw_events),     
.emif_hps_pll_ref_clk_clk               (emif_hps_pll_ref_clk),   
.emif_hps_mem_mem_ck                    (emif_hps_mem_mem_ck),   
.emif_hps_mem_mem_ck_n                  (emif_hps_mem_mem_ck_n),  
.emif_hps_mem_mem_a                     (emif_hps_mem_mem_a),       
.emif_hps_mem_mem_act_n                 (emif_hps_mem_mem_act_n),   
.emif_hps_mem_mem_ba                    (emif_hps_mem_mem_ba),      
.emif_hps_mem_mem_bg                    (emif_hps_mem_mem_bg),      
.emif_hps_mem_mem_cke                   (emif_hps_mem_mem_cke),    
.emif_hps_mem_mem_cs_n                  (emif_hps_mem_mem_cs_n),    
.emif_hps_mem_mem_odt                   (emif_hps_mem_mem_odt),     
.emif_hps_mem_mem_reset_n               (emif_hps_mem_mem_reset_n),
.emif_hps_mem_mem_par                   (emif_hps_mem_mem_par),          
.emif_hps_mem_mem_alert_n               (emif_hps_mem_mem_alert_n),    
.emif_hps_mem_mem_dqs                   (emif_hps_mem_mem_dqs),       
.emif_hps_mem_mem_dqs_n                 (emif_hps_mem_mem_dqs_n),     
.emif_hps_mem_mem_dq                    (emif_hps_mem_mem_dq), 
.emif_hps_mem_mem_dbi_n                 (emif_hps_mem_mem_dbi_n), 
.emif_hps_oct_oct_rzqin                 (emif_hps_oct_oct_rzqin), 
.hps_io_hps_io_jtag_tck                 (hps_jtag_tck),                
.hps_io_hps_io_jtag_tms                 (hps_jtag_tms),                
.hps_io_hps_io_jtag_tdo                 (hps_jtag_tdo),                 
.hps_io_hps_io_jtag_tdi                 (hps_jtag_tdi),    
.hps_io_hps_io_phery_emac0_TX_CLK       (hps_emac0_TX_CLK),     
.hps_io_hps_io_phery_emac0_RX_CLK       (hps_emac0_RX_CLK),     
.hps_io_hps_io_phery_emac0_TX_CTL       (hps_emac0_TX_CTL),    
.hps_io_hps_io_phery_emac0_RX_CTL       (hps_emac0_RX_CTL),    
.hps_io_hps_io_phery_emac0_TXD0         (hps_emac0_TXD0),     
.hps_io_hps_io_phery_emac0_TXD1         (hps_emac0_TXD1),
.hps_io_hps_io_phery_emac0_RXD0         (hps_emac0_RXD0),       
.hps_io_hps_io_phery_emac0_RXD1         (hps_emac0_RXD1),        
.hps_io_hps_io_phery_emac0_TXD2         (hps_emac0_TXD2),      
.hps_io_hps_io_phery_emac0_TXD3         (hps_emac0_TXD3),   
.hps_io_hps_io_phery_emac0_RXD2         (hps_emac0_RXD2),        
.hps_io_hps_io_phery_emac0_RXD3         (hps_emac0_RXD3),
.hps_io_hps_io_phery_emac0_MDIO         (hps_emac0_MDIO),       
.hps_io_hps_io_phery_emac0_MDC          (hps_emac0_MDC), 
.hps_io_hps_io_phery_sdmmc_CCLK         (hps_sdmmc_CCLK),   
.hps_io_hps_io_phery_sdmmc_CMD          (hps_sdmmc_CMD), 
.hps_io_hps_io_phery_sdmmc_D0           (hps_sdmmc_D0),          
.hps_io_hps_io_phery_sdmmc_D1           (hps_sdmmc_D1),          
.hps_io_hps_io_phery_sdmmc_D2           (hps_sdmmc_D2),         
.hps_io_hps_io_phery_sdmmc_D3           (hps_sdmmc_D3),        
.hps_io_hps_io_phery_i2c1_SDA           (hps_i2c1_SDA),     
.hps_io_hps_io_phery_i2c1_SCL           (hps_i2c1_SCL),
.hps_io_hps_io_phery_uart0_RX           (hps_uart0_RX),          
.hps_io_hps_io_phery_uart0_TX           (hps_uart0_TX), 
.hps_io_hps_io_phery_usb0_CLK           (hps_usb0_CLK), 
.hps_io_hps_io_phery_usb0_STP           (hps_usb0_STP), 
.hps_io_hps_io_phery_usb0_DIR           (hps_usb0_DIR),
.hps_io_hps_io_phery_usb0_NXT           (hps_usb0_NXT),
.hps_io_hps_io_phery_usb0_DATA0         (hps_usb0_DATA0),
.hps_io_hps_io_phery_usb0_DATA1         (hps_usb0_DATA1), 
.hps_io_hps_io_phery_usb0_DATA2         (hps_usb0_DATA2), 
.hps_io_hps_io_phery_usb0_DATA3         (hps_usb0_DATA3), 
.hps_io_hps_io_phery_usb0_DATA4         (hps_usb0_DATA4), 
.hps_io_hps_io_phery_usb0_DATA5         (hps_usb0_DATA5),
.hps_io_hps_io_phery_usb0_DATA6         (hps_usb0_DATA6), 
.hps_io_hps_io_phery_usb0_DATA7         (hps_usb0_DATA7),
.hps_io_hps_io_gpio_gpio1_io0           (hps_gpio1_io0),
.hps_io_hps_io_gpio_gpio1_io1           (hps_gpio1_io1),
.hps_io_hps_io_gpio_gpio1_io4           (hps_gpio1_io4),
.hps_io_hps_io_gpio_gpio1_io5           (hps_gpio1_io5),
.hps_io_hps_io_gpio_gpio1_io19           (hps_gpio1_io19),
.hps_io_hps_io_gpio_gpio1_io20           (hps_gpio1_io20),
.hps_io_hps_io_gpio_gpio1_io21           (hps_gpio1_io21),
.f2h_irq1_irq                           (f2h_irq1_irq),

.mge_10gbe_clk_156p25_clk                  (mge_10gbe_clk_156p25),
.sfp_control_pio_in_port                   (sfp_control),
.sfp_control_pio_out_port                  (sfp_control),
.mge_10gbe_status_pio_export               (mge_10gbe_status),
.mge_10gbe_debug_status_pio_export         (mge_10gbe_debug_status),
.mge_10gbe_mac_link_status_pio_export      (mge_10gbe_mac_link_status),
.mge_10gbe_tod_start_sync_ctrl_pio_in_port   (mge_10gbe_tod_start_sync_ctrl),
.mge_10gbe_tod_start_sync_ctrl_pio_out_port  (mge_10gbe_tod_start_sync_ctrl),
.sfp_i2c_scl_in_clk                        (sfpa_i2c_scl),
.sfp_i2c_clk_clk                           (sfp_i2c_scl_oe),
.sfp_i2c_sda_i                             (sfpa_i2c_sda),
.sfp_i2c_sda_oe                            (sfp_i2c_sda_oe),
.mge_refclk_csr_clk                        (enet_refclk),
.mge_refclk_csr_out_clk                    (mge_csr_clk),
.mge_reset_csr_out_reset                   (mge_reset_csr_clk),
.mge_csr_waitrequest                       (mge_csr_waitrequest),
.mge_csr_readdata                          (mge_csr_readdata),
.mge_csr_readdatavalid                     (mge_csr_readdatavalid),
.mge_csr_burstcount                        (mge_csr_burstcount),
.mge_csr_writedata                         (mge_csr_writedata),
.mge_csr_address                           (mge_csr_address),
.mge_csr_write                             (mge_csr_write),
.mge_csr_read                              (mge_csr_read),
.mge_csr_byteenable                        (mge_csr_byteenable),
.mge_csr_debugaccess                       (mge_csr_debugaccess),
.mge_rx_dma_ch1_pause_control_data         (mge_avalon_st_pause_data[0]),
.mge_rx_dma_ch1_pktin_data                 (mge_avalon_st_rx_data[0]),
.mge_rx_dma_ch1_pktin_valid                (mge_avalon_st_rx_valid[0]),
.mge_rx_dma_ch1_pktin_ready                (mge_avalon_st_rx_ready[0]),
.mge_rx_dma_ch1_pktin_startofpacket        (mge_avalon_st_rx_startofpacket[0]),
.mge_rx_dma_ch1_pktin_endofpacket          (mge_avalon_st_rx_endofpacket[0]),
.mge_rx_dma_ch1_pktin_empty                (mge_avalon_st_rx_empty[0]),
.mge_rx_dma_ch1_pktin_error                (mge_avalon_st_rx_error[0]),
.mge_rx_dma_ch1_timestamp_valid            (mge_rx_ingress_timestamp_96b_valid[0]),
.mge_rx_dma_ch1_timestamp_data             (mge_rx_ingress_timestamp_96b_data[0]),
.mge_tx_dma_ch1_timestamp_valid            (mge_tx_egress_timestamp_96b_valid[0]),
.mge_tx_dma_ch1_timestamp_data             (mge_tx_egress_timestamp_96b_data[0]),
.mge_tx_dma_ch1_timestamp_fingerprint      (mge_tx_egress_timestamp_96b_fingerprint[0]),
.mge_tx_dma_ch1_pktout_valid               (mge_avalon_st_tx_valid[0]),
.mge_tx_dma_ch1_pktout_ready               (mge_avalon_st_tx_ready[0]),
.mge_tx_dma_ch1_pktout_data                (mge_avalon_st_tx_data[0]),
.mge_tx_dma_ch1_pktout_empty               (mge_avalon_st_tx_empty[0]),
.mge_tx_dma_ch1_pktout_error               (mge_avalon_st_tx_error[0]),
.mge_tx_dma_ch1_pktout_endofpacket         (mge_avalon_st_tx_endofpacket[0]),
.mge_tx_dma_ch1_pktout_startofpacket       (mge_avalon_st_tx_startofpacket[0]),
.mge_tx_dma_ch1_timestamp_req_valid        (mge_tx_egress_timestamp_request_in_valid[0]),
.mge_tx_dma_ch1_timestamp_req_fingerprint  (mge_tx_egress_timestamp_request_in_fingerprint[0]),

.h2f_reset_reset                        (h2f_reset),
.hps_io_hps_io_hps_ocs_clk              (hps_ref_clk)
);  

alt_mge_rd #(
.NUM_OF_CHANNEL       (1),
.MAX_NUM_OF_CHANNEL   (2)
) alt_mge_10gbe_inst (
   // CSR Clock
   .csr_clk                (mge_csr_clk),
   .reset_csr_clk          (mge_reset_csr_clk),
    
   // MAC Clock
   .mac_clk                (),
    
   // XGMII Clock
   .mac64b_clk             (mge_10gbe_clk_156p25),
    
   // Reference Clock
   .refclk_1g2p5g          (mge_refclk_125m),
   .refclk_core            (mge_refclk_125m),
   .refclk_10g             (mge_refclk_10g),
   
   // Reset
   .reset                  (~system_reset_n),
   .tx_digitalreset        (),
   .rx_digitalreset        (),
   .rx_digitalreset_stat   (),
   
   //CSR
   .csr_address            (mge_csr_address      ),
   .csr_write              (mge_csr_write        ),
   .csr_read               (mge_csr_read         ),
   .csr_waitrequest        (mge_csr_waitrequest  ),
   .csr_byteenable         (mge_csr_byteenable   ),
   .csr_debugaccess        (mge_csr_debugaccess  ),
   .csr_burstcount         (mge_csr_burstcount   ),
   .csr_writedata          (mge_csr_writedata    ),
   .csr_readdata           (mge_csr_readdata     ),
   .csr_readdatavalid      (mge_csr_readdatavalid),
   
   
   // MAC TX User Frame
   .avalon_st_tx_valid           (mge_avalon_st_tx_valid        ),
   .avalon_st_tx_ready           (mge_avalon_st_tx_ready        ),
   .avalon_st_tx_startofpacket   (mge_avalon_st_tx_startofpacket),
   .avalon_st_tx_endofpacket     (mge_avalon_st_tx_endofpacket  ),
   .avalon_st_tx_data            (mge_avalon_st_tx_data         ),
   .avalon_st_tx_empty           (mge_avalon_st_tx_empty        ),
   .avalon_st_tx_error           (mge_avalon_st_tx_error        ),
   
   // MAC RX User Frame
   .avalon_st_rx_valid           (mge_avalon_st_rx_valid        ),
   .avalon_st_rx_ready           (mge_avalon_st_rx_ready        ),
   .avalon_st_rx_startofpacket   (mge_avalon_st_rx_startofpacket),
   .avalon_st_rx_endofpacket     (mge_avalon_st_rx_endofpacket  ),
   .avalon_st_rx_data            (mge_avalon_st_rx_data         ),
   .avalon_st_rx_empty           (mge_avalon_st_rx_empty        ),
   .avalon_st_rx_error           (mge_avalon_st_rx_error        ),
   
   // MAC TX Frame Status
   .avalon_st_txstatus_valid     (),
   .avalon_st_txstatus_data      (),
   .avalon_st_txstatus_error     (),
   
   // MAC RX Frame Status
   .avalon_st_rxstatus_valid     (),
   .avalon_st_rxstatus_data      (),
   .avalon_st_rxstatus_error     (),
   
   // MAC TX Pause Frame Generation Command
   .avalon_st_pause_data         (mge_avalon_st_pause_data),
   
   // MAC Status
   .xgmii_rx_link_fault_status   (mge_xgmii_rx_link_fault_status),
   
   // PHY Status
   .led_link                     (mge_led_link     ),
   .led_char_err                 (mge_led_char_err ),
   .led_disp_err                 (mge_led_disp_err ),
   .led_an                       (mge_led_an       ),
   .rx_block_lock                (mge_rx_block_lock),
   
   // Transceiver Serial Interface
   .tx_serial_data               (mge_10gbe_txp),
   .rx_serial_data               (mge_10gbe_rxp),
   .rx_pma_clkout                (),
   
   // Data Path Readiness
   .channel_tx_ready             (mge_channel_tx_ready),
   .channel_rx_ready             (mge_channel_rx_ready),
      
   .xcvr_mode_out                (),
   
   // 1588
   .tx_egress_timestamp_request_in_valid        (mge_tx_egress_timestamp_request_in_valid      ),
   .tx_egress_timestamp_request_in_fingerprint  (mge_tx_egress_timestamp_request_in_fingerprint),
   
   .tx_egress_timestamp_96b_valid               (mge_tx_egress_timestamp_96b_valid      ),
   .tx_egress_timestamp_96b_data                (mge_tx_egress_timestamp_96b_data       ),
   .tx_egress_timestamp_96b_fingerprint         (mge_tx_egress_timestamp_96b_fingerprint),
   
   .rx_ingress_timestamp_96b_valid              (mge_rx_ingress_timestamp_96b_valid),
   .rx_ingress_timestamp_96b_data               (mge_rx_ingress_timestamp_96b_data ),
   
   .start_tod_sync                              (mge_start_tod_sync          ),
   .pulse_per_second                            (mge_pulse_per_second        ),
   .master_pulse_per_second                     (mge_master_pulse_per_second ),
   .core_pll_locked                             (mge_core_pll_locked         ),
   .xcvr_sampling_pll_locked                    (mge_xcvr_sampling_pll_locked),
   .tod_sampling_pll_locked                     (mge_tod_sampling_pll_locked )
);

// debounce fpga_reset_n
debounce fpga_reset_n_debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (~ninit_done),
.data_in      (fpga_reset_n),
.data_out     (fpga_reset_n_debounced_wire)
);
defparam fpga_reset_n_debounce_inst.WIDTH = 1;
defparam fpga_reset_n_debounce_inst.POLARITY = "LOW";
defparam fpga_reset_n_debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam fpga_reset_n_debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @ (posedge system_clk_100_internal or posedge ninit_done)
begin
    if (ninit_done == 1'b1)
        fpga_reset_n_debounced <= 1'b0;
    else
        fpga_reset_n_debounced <= fpga_reset_n_debounced_wire;  
end

// Debounce logic to clean out glitches within 1ms
debounce debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (system_reset_n),  
.data_in      (fpga_button_pio),
.data_out     (fpga_debounced_buttons)
);
defparam debounce_inst.WIDTH = 4;
defparam debounce_inst.POLARITY = "LOW";
defparam debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @(posedge system_clk_100_internal or negedge system_reset_n) begin
  if (~system_reset_n)
    heartbeat_count <= 23'd0;
  else
    heartbeat_count <= heartbeat_count + 23'd1;
end


endmodule


